<?php
namespace Geral\Util;

/**
 * Created by JetBrains PhpStorm.
 * User: paulopereira
 * Date: 19/11/12
 * Time: 16:22
 * To change this template use File | Settings | File Templates.
 */
class Mensagem
{

    /** @var $texto string texto da mensagem. */
    private $texto;
    /** @var $parametros array lista de parametros para a mensagem de erro. */
    private $parametros;
    /** @var $tipoMensagem string*/
    private $tipoMensagem;

    /**
     * Tipo de mensagem que informe algum erro no processo que nao interfere no seu sucesso.
     */
    const ALERTA    = "A";
    /**
     * Tipo de mensagem que prove informacoes adicionais sobre o processo.
     */
    const VALIDACAO = "V";
    /**
     * Tipo de mensagem que deve parar a execucao do processo assim que tratada.
     */
    const ERRO      = "E";


    /**
     * @param $parametros
     */
    public function setParametros($parametros)
    {
        $this->parametros = $parametros;
    }

    /**
     * @return array
     */
    public function getParametros()
    {
        return $this->parametros;
    }

    /**
     * @param $texto
     */
    public function setTexto($texto)
    {
        $this->texto = $texto;
    }

    /**
     * @return mixed
     */
    public function getTexto()
    {
        return $this->texto;
    }

    /**
     * @param $tipoMensagem
     */
    public function setTipoMensagem($tipoMensagem)
    {
        $this->tipoMensagem = $tipoMensagem;
    }

    /**
     * @return mixed
     */
    public function getTipoMensagem()
    {
        return $this->tipoMensagem;
    }

}
