<?php

/**
 * FpaReports
 * Folha2, from 'logic'
 * @package Facade
 * @author  gabriellopes
 *
 */

class FpaReports{

    const MSG_DTINI_INVALID = 'Campo "Data Inicial" Inválido!';
    const MSG_DTFIM_INVALID = 'Campo "Data Final" Inválido!';
    const MSG_DTEMISSAORELATORIO_INVALID = 'Campo "Data de Emissão do Relatório" Inválido!';
    const MSG_DTAVISOPREVFERIAS_INVALID = 'Campo "Data Emissão Aviso Prévio Férias" Inválido!';
    const MSG_DTCALCONTRACHEQUEFERIAS = 'Campo "Data de Cálculo do Contra Cheque de Férias" Inválido!';

    //const QRY_CONF_RESTR = "VH.CONFIDENCIAL = 'N'";				//Fragmento de query que apenas selecionas vínculos não confidênciais
    //const QRY_CONF_AUTOR = "(VH.CONFIDENCIAL = 'S' OR 1 = 1)";	//Fragmento de query que seleciona vínculos confidênciais e não confidenciais. (OBS.: Não esquecer os parênteses; o 'S' e o 'N' devem ficar entre aspas simples)
    public static function setQueryConfidencial($SelConf) {
        //Método que gera um fragmento de query para a questão do tratamento de listagem de vínculo confidênciais
        //USO: No final da passagem de valores para o array de parâmetrosd do birt. Inserir este código: $params['P_CONFIDENCIAL'] = setQueryConfidencial();
        if(FPA::getRestConfidencial() == 'S')	//Restringe confidencial
        {										//Somente vínculos não confidênciais
            return "VH.CONFIDENCIAL = 'N'";     //Fragmento de query que apenas selecionas vínculos não confidênciais
        } else {                                //Vínculos confidênciais e não confidenciais
            /*if($SelConf == null) {              //Caso o campo esteja vazio seguirá o padrão: apenas vínculos não confidênciais
                return "VH.CONFIDENCIAL = 'N'";     //Fragmento de query que apenas selecionas vínculos não confidênciais
            }*/
            switch($SelConf) {                 //Seleciona o tipo de vínculo a ser exibido
                case 'tudo':
                    return "(VH.CONFIDENCIAL = 'S' OR 1 = 1)";  //Fragmento de query que seleciona vínculos confidênciais e não confidenciais. (OBS.: Não esquecer os parênteses; o 'S' e o 'N' devem ficar entre aspas simples)
                    break;
                case 'nao_conf':
                case null:
                    return "VH.CONFIDENCIAL = 'N'";             //Fragmento de query que apenas selecionas vínculos não confidênciais
                    break;
                case 'som_conf':
                    return "(VH.CONFIDENCIAL = 'S')";           //Fragmento de query que seleciona apenas vínculos confidenciais.
                    break;
                default:
                    tk_warning('A função setQueryConfidencial() recebeu um parâmetro inválido: '.$SelConf);
            } //fim do switch
        }
    }

    public static function geraRelatorio() {
        //* Inicia capturando o nome de relatorio
        $nmreport = tk_get_field_value('NMREPORT');

        switch($nmreport){
            case 'folha_analitica':
                self :: folhaAnalitica($nmreport);
                break;

            case 'liquido':
                self :: liquido($nmreport);
                break;

            case 'liquidobanco':
                self :: liquidobanco($nmreport);
                break;

            case 'liquidocaixa':
                self :: liquidocaixa($nmreport);
                break;

            case 'comparacao_movimentos_folha_analitica';
                self :: comparacaoMovimentosFolhaAnalitica($nmreport);
                break;

            case 'aviso_previo_ferias':
                self :: avisoPrevioFerias($nmreport);
                break;

            case 'declaracao_encargos_familia_imposto_de_renda':
                self :: declaracaoEncargosFamiliaImpostoRenda($nmreport);
                break;

            case 'resumo_folha':
                self :: resumoFolha($nmreport);
                break;

            case 'registro_empregado':
                self :: registroEmpregado($nmreport);
                break;

            case 'declaracao_salario_familia':
                self :: declaracaoSalarioFamilia($nmreport);
                break;

            case 'declaracao_vale_transporte':
                self :: declaracaoValeTransporte($nmreport);
                break;

            case 'ficha_financeira':
                self :: fichaFinanceira($nmreport);
                break;
            case 'ficha_financeira_grade':
                self :: fichaFinanceiraGrade($nmreport);
                break;

            case 'ficha_financeira_analitica':
                self :: fichaFinanceiraAnalitica($nmreport);
                break;

            case 'contrato_trabalho_regime_experiencia':
                self :: contratoTrabalhoRegimeExperiencia($nmreport);
                break;

            case 'termo_prorrogacao':
                self :: termoProrrogacao($nmreport);
                break;

            case 'medias_ferias': //REVER ESTE!!!
                self :: mediasFerias($nmreport);
                break;

            case 'medias_rescisao_ferias':
                self :: medias_rescisao_ferias($nmreport);
                break;

            case 'medias_rescisao_aviso_prev':
                self :: medias_rescisao_aviso_prev($nmreport);
                break;

            case 'medias_rescisao_13':
                self :: medias_rescisao_13($nmreport);
                break;

            case 'folha_ponto':
                self :: folhaPonto($nmreport);
                break;

            case 'turn_over':
                self :: turnOver($nmreport);
                break;

            case 'recibo_ferias':
                self :: reciboFerias($nmreport);
                break;

            case 'relacao_contribuicao_sindical':
                self :: relacaoContribuicaoSindical($nmreport);
                break;

            case 'relacao_funcionario_por_estrutura':
                self :: relacaoFuncionarioPorEstrutura($nmreport);
                break;

            case 'relacao_funcionario_por_sindicato':
                self :: relacao_funcionario_por_sindicato($nmreport);
                break;

            case 'demonstrativo_pagamento_lab02':
                self :: demonstrativo_pagamento_lab02($nmreport);
                break;

            case 'demonstrativo_pagamento_laser':
                self :: demonstrativo_pagamento_laser($nmreport);
                break;

            case 'funcionarios_admitidos_periodo':
                self :: funcionariosAdmitidosPeriodo($nmreport);
                break;

            case 'funcionarios_demitidos_periodo':
                self :: funcionariosDemitidosPeriodo($nmreport);
                break;

            case 'controle_contrato_experiencia':
                self :: controleContratoExperiencia($nmreport);
                break;

            case 'etiqueta':
                self :: etiqueta($nmreport);
                break;

            case 'aviso_previo_empregado':
                self :: avisoprevioempregado($nmreport);
                break;

            case 'aviso_previo_empregador':
                self :: avisoprevioempregador($nmreport);
                break;

            case 'darf':
                self :: darf($nmreport);
                break;

            case 'gps':
                self :: gps($nmreport);
                break;

            case 'seguro_desemprego':
                self :: seguro_desemprego($nmreport);
                break;

            case 'previsao_ferias':
                self :: previsao_ferias($nmreport);
                break;

            case 'conta_funcionario':
                self :: conta_funcionario($nmreport);
                break;

            case 'estruturas_tipo_hierarquia':
                self :: estruturas_tipo_hierarquia($nmreport);
                break;

            case 'aniversariantes':
                self :: aniversariantes($nmreport);
                break;

            case 'comparacao_calculos_folha':
                self :: comparacao_calculos_folha($nmreport);
                break;

            case 'assoc_eventos_vinculo_v':
                self :: assoc_eventos_vinculo_v($nmreport);
                break;

            case 'assoc_eventos_vinculo_e':
                self :: assoc_eventos_vinculo_e($nmreport);
                break;

            case 'assoc_estrutura_evento':
                self :: assoc_estrutura_evento($nmreport);
                break;

            case 'eventos_relacionados_vinculo':
                self :: eventos_relacionados_vinculo($nmreport);
                break;

            case 'tomadores':
                self :: tomadores($nmreport);
                break;

            case 'alteracao_salarial':
                self :: alteracao_salarial($nmreport);
                break;

            case 'lancamentos_evento_vinculo':
                self :: lancamentos_evento_vinculo($nmreport);
                break;

            case 'relacao_eventos_estrutura_e_vinculo':
                self :: relacao_eventos_estrutura_e_vinculo($nmreport);
                break;

            case 'evento_zerado_por_vinculo':
                self :: evento_zerado_por_vinculo($nmreport);
                break;

            default:
                tk_warning('Relatório ainda não integrado ao sistema!');
                break;
        }

    }

    /*
    * Desativa os campos do relatório até que uma data de competência válida seja digitada.
    */
    public static function disableFieldsWhenCompetenceDateIsUnvalid(){

        tk_disable_field('NRESTRUTURA');
        tk_disable_field('NMREPORT');
        tk_disable_field('MESCOMPB');
        tk_disable_field('NOMEVINCULOATIVO');
        tk_disable_field('NOMEVINCULO');
        tk_disable_field('NRTPMODALIDCAL');
        tk_disable_field('NRTPMODALIDCALB');
        tk_disable_field('DATAINICIAL');
        tk_disable_field('DATAFINAL');
        tk_disable_field('DATA_AVISO_PREVIO_FERIAS');
        tk_disable_field('NRTIPOMOVIMENT');
        tk_disable_field('TIPOMOVIMENTO'); //pck
        tk_disable_field('ZEBRADO');
        tk_disable_field('DATA_CALCULO_CONTRA_CHEQUE_FERIAS');
        //tk_disable_field('DATA_EMISSAO_RELATORIO');
    }

    /*
    * Ativa os campos do relatório quando uma data de competencia válida é digitada.
    */
    public static function enableFieldsWhenCompetenceDateIsValid(){

        tk_enable_field('NRESTRUTURA');
        tk_enable_field('NMREPORT');
        tk_enable_field('MESCOMPB');
        tk_enable_field('NOMEVINCULOATIVO');
        tk_enable_field('NOMEVINCULO');
        tk_enable_field('NRTPMODALIDCAL');
        tk_enable_field('NRTPMODALIDCALB');
        tk_enable_field('DATAINICIAL');
        tk_enable_field('DATAFINAL');
        tk_enable_field('DATA_AVISO_PREVIO_FERIAS');
        tk_enable_field('NRTIPOMOVIMENT');
        tk_enable_field('TIPOMOVIMENTO'); //pck
        tk_enable_field('ZEBRADO');
        tk_enable_field('DATA_CALCULO_CONTRA_CHEQUE_FERIAS');
        //tk_enable_field('DATA_EMISSAO_RELATORIO');
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Folha Analítica"
    * e faz a chamada do relatório correspondênte.
    */
    public static function folhaAnalitica($nmreport) {
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrTpModalidCal   = tk_get_field_value('NRTPMODALIDCAL');
        $tipoMovimento    = tk_get_field_value('TIPOMOVIMENTO');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');

        if($nrTpModalidCal != null && $tipoMovimento != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_COMPETENCIA']    = $mesComp; //PCK Nova ver
            $params['P_NRORG']          = $nrOrg;
            $params['P_ESTRUTURALEGAL'] = $nrEstrutura; //PCK Nova ver
            $params['P_MODALIDADECAL']  = $nrTpModalidCal; //PCK Nova ver
            $params['P_TIPOMOVIMENTO']  = $tipoMovimento; //PCK Nova ver
            $params['P_ESTRUTURAGEREN'] = $nrEstruturaGeren; //PCK Nova ver
            $params['ZEBRADO']          = $zebrado;
            $params['P_OCORRECAL']      = \FPA::getOcorrenciaCalculo(); //PCK Nova ver
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial(tk_get_field_value('SELECAOCONF')); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('Os campos "Modalidade de Cálculo" e "Tipo de Movimento" devem ser preenchidos para a emissão do relatório!');
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Folha Analítica"
    * e faz a chamada do relatório correspondênte.
    */
    public static function liquido($nmreport) {
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrTpModalidCal   = tk_get_field_value('NRTPMODALIDCAL');
        $tipoMovimento    = tk_get_field_value('TIPOMOVIMENTO');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL'); //pck
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS'); //pck
        $NrEvento         = tk_get_field_value('NREVENTO'); //pck

        if($nrTpModalidCal == null || $tipoMovimento == null || $IncluirDemitidos == null || $NrEvento == null){
            tk_warning('Os campos "Modalidade de Cálculo", "Tipo de Movimento", "Incluir funcionários demitidos?" e "Nro Evento" devem ser preenchidos para a emissão do relatório Líquidos Geral.');
        }else{
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC']   = $mesComp;
            $params['P_NRORG']            = $nrOrg;
            $params['P_NRESTRUTURA']      = $nrEstrutura;
            $params['P_NRTPMODALIDCAL']   = $nrTpModalidCal;
            $params['P_NRTPMOVIMENT']     = $tipoMovimento; //$nrTpMoviment; //pck
            $params['ZEBRADO']            = $zebrado;
            $params['P_NRESTRUTURAGEREN'] = $nrEstruturaGeren;
            $params['P_INCLUIRDEMITIDO']  = $IncluirDemitidos;  //pck
            $params['P_NREVENTO']         = $NrEvento;          //pck
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial(tk_get_field_value('SELECAOCONF')); //Parâmetro de confidencialidade
            $params['CDOPERADOR']         = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']         = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function liquidobanco($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrTpModalidCal   = tk_get_field_value('NRTPMODALIDCAL');
        $tipoMovimento    = tk_get_field_value('TIPOMOVIMENTO');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL'); //pck
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS'); //pck
        $NrEvento         = tk_get_field_value('NREVENTO'); //pck

        if($nrTpModalidCal == null || $tipoMovimento == null || $IncluirDemitidos == null || $NrEvento == null){
            tk_warning('Os campos "Modalidade de Cálculo", "Tipo de Movimento", "Incluir funcionários demitidos?" e "Nro Evento" devem ser preenchidos para a emissão do relatório Líquidos do Banco.');
        }else{
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC']   = $mesComp;
            $params['P_NRORG']            = $nrOrg;
            $params['P_NRESTRUTURA']      = $nrEstrutura;
            $params['P_NRTPMODALIDCAL']   = $nrTpModalidCal;
            $params['P_NRTPMOVIMENT']     = $tipoMovimento; //$nrTpMoviment; //pck
            $params['ZEBRADO']            = $zebrado;
            $params['P_NRESTRUTURAGEREN'] = $nrEstruturaGeren;
            $params['P_INCLUIRDEMITIDO']  = $IncluirDemitidos; //pck
            $params['P_NREVENTO']         = $NrEvento;          //pck
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial(tk_get_field_value('SELECAOCONF')); //Parâmetro de confidencialidade
            $params['CDOPERADOR']         = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']         = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public Static function liquidocaixa($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrTpModalidCal   = tk_get_field_value('NRTPMODALIDCAL');
        $tipoMovimento    = tk_get_field_value('TIPOMOVIMENTO');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL'); //pck
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS'); //pck
        $NrEvento         = tk_get_field_value('NREVENTO'); //pck

        if($nrTpModalidCal == null || $tipoMovimento == null || $IncluirDemitidos == null || $NrEvento == null){
            tk_warning('Os campos "Modalidade de Cálculo", "Tipo de Movimento", "Incluir funcionários demitidos?" e "Nro Evento" devem ser preenchidos para a emissão do relatório Líquidos Caixa.');
        }else{
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC']   = $mesComp;
            $params['P_NRORG']            = $nrOrg;
            $params['P_NRESTRUTURA']      = $nrEstrutura;
            $params['P_NRTPMODALIDCAL']   = $nrTpModalidCal;
            $params['P_NRTPMOVIMENT']     = $tipoMovimento; //$nrTpMoviment; //pck
            $params['ZEBRADO']            = $zebrado;
            $params['P_NRESTRUTURAGEREN'] = $nrEstruturaGeren;
            $params['P_INCLUIRDEMITIDO']  = $IncluirDemitidos; //pck
            $params['P_NREVENTO']         = $NrEvento;          //pck
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial(tk_get_field_value('SELECAOCONF')); //Parâmetro de confidencialidade
            $params['CDOPERADOR']         = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']         = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Comparação de Movimentos da Folha Analítica"
    * e faz a chamada do relatório correspondênte.
    */
    public static function comparacaoMovimentosFolhaAnalitica($nmreport){
        $mesComp         = tk_get_field_value('MESCOMP');
        $mesCompB        = tk_get_field_value('MESCOMPB');
        $nrTpModalidCal  = tk_get_field_value('NRTPMODALIDCAL');
        $nrTpModalidCalB = tk_get_field_value('NRTPMODALIDCALB');
        $nrEstrutura     = tk_get_field_value('NRESTRUTURA');
        $nrOrg           = tk_get_field_value('NRORG');
        //$zebrado         = tk_get_field_value('ZEBRADO');

        if(($nrTpModalidCal && $nrTpModalidCalB && $mesComp) != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC_A'] = $mesComp;
            $params['P_DTMESCOMPETENC_B'] = $mesCompB;
            $params['P_NRTPMODALIDCAL_A'] = $nrTpModalidCal;
            $params['P_NRTPMODALIDCAL_B'] = $nrTpModalidCalB;
            $params['P_NRESTRUTURA']      = $nrEstrutura;
            $params['P_NRORG']            = $nrOrg;
            //$params['ZEBRADO']            = $zebrado;
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('Os campos "Data de Competência B", "Modalidade de Cálculo" e "Modalidade de Cálculo B" devem ser preenchidos para emissão do relatório!');
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Aviso Prévio de Férias"
    * e faz a chamada do relatório correspondênte.
    */
    public static function avisoPrevioFerias($nmreport){
        $mesComp               = tk_get_field_value('MESCOMP');
        $dataInicial           = tk_get_field_value('DATAINICIAL');
        $dataFinal             = tk_get_field_value('DATAFINAL');
        $nomeVinculoAtivo      = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstrutura           = tk_get_field_value('NRESTRUTURA');
        $nrOrg                 = tk_get_field_value('NRORG');
        $dataAvisoPrevioFerias = tk_get_field_value('DATA_AVISO_PREVIO_FERIAS');

        if(($dataInicial && $dataFinal && $dataAvisoPrevioFerias) != null){
            if(self::validateCommonDate($dataInicial, 'DATAINICIAL', self::MSG_DTINI_INVALID)
                & self::validateCommonDate($dataFinal, 'DATAFINAL', self::MSG_DTFIM_INVALID)
                & self::validateCommonDate($dataAvisoPrevioFerias, 'DATA_AVISO_PREVIO_FERIAS', self::MSG_DTAVISOPREVFERIAS_INVALID)){
                //*Inicia o array que sera enviado para o relatorio
                $params = array();
                $params['P_DTMESCOMPETENC']         = $mesComp;
                $params['P_DATAINICIAL']            = $dataInicial;
                $params['P_DATAFINAL']              = $dataFinal;
                $params['P_NRVINCULO']              = $nomeVinculoAtivo;
                $params['P_NRESTRUTURA']            = $nrEstrutura;
                $params['P_NRORG']                  = $nrOrg;
                $params['DATA_AVISO_PREVIO_FERIAS'] = $dataAvisoPrevioFerias;
                $params['P_CONFIDENCIAL']           = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
                tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
            }
        }else{
            tk_warning('Os campos "Data Inicial", "Data Final" e "Data Emissão Aviso Prévio Férias"
                                devem ser preenchidos para emissão do relatório!');
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio
    * "Declaração de Encargos de Família para imposto de renda" e faz a chamada do relatório correspondênte.
    */
    public static function declaracaoEncargosFamiliaImpostoRenda($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrOrg            = tk_get_field_value('NRORG');
        $zebrado          = tk_get_field_value('ZEBRADO');

        if($nomeVinculoAtivo){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_NRORG']          = $nrOrg;
            $params['ZEBRADO']          = $zebrado;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Resumo da Folha"
    * e faz a chamada do relatório correspondênte.
    */
    public static function resumoFolha($nmreport){
        $mesComp      = tk_get_field_value('MESCOMP');
        $nrOrg        = tk_get_field_value('NRORG');
        $nrEstrutura  = tk_get_field_value('NRESTRUTURA');
        $nrTpMoviment = tk_get_field_value('TIPOMOVIMENTO'); //4 opções: TIPOMOVIMENTO - todas opções: NRTIPOMOVIMENT
        $zebrado      = tk_get_field_value('ZEBRADO');

        if($nrTpMoviment != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTLEGAL']  = $nrEstrutura;
            $params['P_NRTIPOMOVIMENT'] = $nrTpMoviment;
            $params['ZEBRADO']          = $zebrado;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            $params['CDOPERADOR']       = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']       = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('O campo "Tipo de Movimento" deve ser preenchidos para emissão do relatório!');
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Registro do Empregado"
    * e faz a chamada do relatório correspondênte.
    */
    public static function registroEmpregado($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $nrOrg            = tk_get_field_value('NRORG');
        $dataInicial      = tk_get_field_value('DATAINICIAL'); //Pck
        $dataFinal        = tk_get_field_value('DATAFINAL');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $zebrado          = tk_get_field_value('ZEBRADO');

        //if($nomeVinculoAtivo != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_DTINICIO']       = $dataInicial;
            $params['P_DTFINAL']        = $dataFinal;
            $params['ZEBRADO']          = $zebrado;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        /*}else{
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        }*/
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Declaração de Salário Família"
    * e faz a chamada do relatório correspondênte.
    */
    public static function declaracaoSalarioFamilia($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');

        if($nomeVinculoAtivo){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Declaração de Vale Transporte"
    * e faz a chamada do relatório correspondênte.
    */
    public static function declaracaoValeTransporte($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $nrOrg            = tk_get_field_value('NRORG');

        if($nomeVinculoAtivo){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_NRORG']          = $nrOrg;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        }
    }

    /*
     * Geta para um array os parametros necessÃ¡rios para o relatorio "Ficha Financeira"
     * e faz a chamada do relatÃ³rio correspondÃªnte.
     */
    public static function fichaFinanceira($nmreport){
        /*$dataCompetencia = tk_get_field_value('MESCOMP');
        $anoCompetencia = explode('/', $dataCompetencia, 3);
        $anoCompetencia = $anoCompetencia[2];*/
        $anoCompetencia   = tk_get_field_value('ANOCOMPETENCIA'); //Buscando do field em vez do mÃªs de competÃªncia
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');

        if($nomeVinculoAtivo != null && $anoCompetencia != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_ANOCOMPETENCIA'] = $anoCompetencia;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //ParÃ¢metro de confidencial
            tk_open_birt_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('Os campos "Vínculo" e "Ano de competência" devem ser preenchidos para emisso do relatÃ³rio!');
        }
    }

    /*
     * Geta para um array os parametros necessários para o relatorio "Ficha Financeira Grade"
     * e faz a chamada do relatório correspondênte.
     */
    public static function fichaFinanceiraGrade($nmreport) {
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nomeVinculo      = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $nrTpModalidCal   = tk_get_field_value('NRTPMODALIDCAL');
        $tipoMovimento    = tk_get_field_value('TIPOMOVIMENTO');
        $NrEvento         = tk_get_field_value('NREVENTO'); //pck
        $DataInicial      = tk_get_field_value('DATAINICIAL');
        $DataFinal        = tk_get_field_value('DATAFINAL');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS'); //pck

        if($nrTpModalidCal == null || $tipoMovimento == null || $DataInicial == null || $DataFinal == null ) {
            tk_warning('Os campos Modalidade de Cálculo, Tipo de Movimento e Data Inicial e Final devem ser preenchidos para a emissão do relatório Ficha Analítica.');
        }else{
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_COMPETENCIA']     = $mesComp;
            $params['P_NRORG']           = $nrOrg;
            $params['P_VINCULO']         = $nomeVinculo;
            $params['P_ESTRUTLEGAL']     = $nrEstrutura;
            $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
            $params['P_NRTPMODALIDCAL']  = $nrTpModalidCal;
            $params['P_NRTPMOVIMENT']    = $tipoMovimento;
            $params['P_NREVENTO']        = $NrEvento;
            $params['P_INICIO']          = $DataInicial;
            $params['P_FIM']             = $DataFinal;
            $params['ZEBRADO']           = $zebrado;
            $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
            $params['P_OCORRECAL']       = \FPA::getOcorrenciaCalculo();
            $params['P_CONFIDENCIAL']    = self::setQueryConfidencial(tk_get_field_value('SELECAOCONF')); //Parâmetro de confidencialidade
            $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']        = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    /*
     * Geta para um array os parametros necessários para o relatorio "Ficha Financeira Analítica"
     * e faz a chamada do relatório correspondênte.
     */
    public static function fichaFinanceiraAnalitica($nmreport){
        /*$competenceDate = tk_get_field_value('MESCOMP');
        $competenceYear = explode('/', $competenceDate, 3);
        $competenceYear = $competenceYear[2];*/
        $anoCompetencia   = tk_get_field_value('ANOCOMPETENCIA'); //Buscando do field em vez do mês de competência
        $nrOrg            = tk_get_field_value('NRORG');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');

        if($nomeVinculoAtivo != null && $anoCompetencia != null) {
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_ANOCOMP']          = $anoCompetencia; //$competenceYear;
            $params['P_NRORG']            = $nrOrg;
            $params['P_NRVINCULOM']       = $nomeVinculoAtivo;
            $params['P_NRESTRUTURALEGAL'] = $nrEstrutura;
            $params['P_NRESTRUTURAGEREN'] = $nrEstruturaGeren;
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
            tk_open_birt_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('Os campos "Ano do competência" e "Vinculo" devem ser preenchidos para emissão do relatório');
        }
    }

    /*
     * Geta para um array os parametros necessários para o relatorio "Contrato de Trabalho - Regime de Experiência"
     * e faz a chamada do relatório correspondênte.
     */
    public static function contratoTrabalhoRegimeExperiencia($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrOrg            = tk_get_field_value('NRORG');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');

        if(($nomeVinculoAtivo) != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        }
    }

    /*
     * Geta para um array os parametros necessários para o relatorio "Termo de Prorrogação do Contrato de Experiência"
     * e faz a chamada do relatório correspondênte
     */
    public static function termoProrrogacao($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrOrg            = tk_get_field_value('NRORG');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        //$dataEmissaoRelatorio = tk_get_field_value('DATA_EMISSAO_RELATORIO');

        if($nomeVinculoAtivo != null){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRVINCULO']      = $nomeVinculoAtivo;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
            $params['CDOPERADOR']       = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']       = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        }
    }

    /*
     * Geta para um array os parametros necessários para o relatorio "Médias de Férias"
     * e faz a chamada do relatório correspondênte.
     */
    public static function mediasFerias($nmreport){
        $mesComp     = tk_get_field_value('MESCOMP');
        //$nrEstrutura = tk_get_field_value('NRESTRUTURA');
        $nrOrg       = tk_get_field_value('NRORG');
        //$nomeVinculo = tk_get_field_value('NOMEVINCULO');
        $nomeVinculo = tk_get_field_value('NOMEVINCULOATIVO');
        $dataInicial = tk_get_field_value('INIGOZO'); //pck
        $dataFinal   = tk_get_field_value('FIMGOZO');   //pck
        $zebrado     = tk_get_field_value('ZEBRADO');

        if($dataInicial == null || $dataFinal == null) {
            tk_warning('OS campos de datas referente ao gozo de férias devem ser preenchidos para emissão do relatório');
        } else {
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp; //ok
            //$params['P_NRESTRUTLEGAL']  = $nrEstrutura;
            $params['P_NRORG']          = $nrOrg; //ok
            $params['P_NRVINCULO']      = $nomeVinculo;
            $params['P_DTINIGOZO']      = $dataInicial; //pck
            $params['P_DTFIMGOZO']      = $dataFinal;   //pck
            $params['ZEBRADO']          = $zebrado;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
            $params['CDOPERADOR']       = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']       = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Medias para rescisão para o cálculo de férias"
    * e faz a chamada do relatório correspondênte.
    */
    public static function medias_rescisao_ferias($nmreport) {
        $mesComp     = tk_get_field_value('MESCOMP');
        $nrOrg       = tk_get_field_value('NRORG');
        $nrVinculo   = tk_get_field_value('NOMEVINCULOATIVO');
        $nrLegal     = tk_get_field_value('NRESTRUTURA');
        $nrGerencial = tk_get_field_value('NRESTRUTGERENCIAL');
        $dtIni       = tk_get_field_value('DATAINICIAL');
        $dtFim       = tk_get_field_value('DATAFINAL');
        $zebrado     = tk_get_field_value('ZEBRADO');
        //Não há parâmetros obrigatórios
        //Inicia o array que sera enviado para o relatorio
        $params['P_COMPETENCIA'] = $mesComp;
        $params['P_NRORG']       = $nrOrg;
        $params['P_VINCULO']     = $nrVinculo;
        $params['P_ESTRUTLEGAL'] = $nrLegal;
        $params['P_ESTRUTGEREN'] = $nrGerencial;
        $params['ZEBRADO']       = $zebrado;
        $params['P_INICIO']      = $dtIni;
        $params['P_FINAL']       = $dtFim;
        $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
        $params['CDOPERADOR']     = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']     = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Medias para rescisão para o cálculo de aviso prévio"
    * e faz a chamada do relatório correspondênte.
    */
    public static function medias_rescisao_aviso_prev($nmreport) {
        $mesComp     = tk_get_field_value('MESCOMP');
        $nrOrg       = tk_get_field_value('NRORG');
        $nrVinculo   = tk_get_field_value('NOMEVINCULOATIVO');
        $nrLegal     = tk_get_field_value('NRESTRUTURA');
        $nrGerencial = tk_get_field_value('NRESTRUTGERENCIAL');
        $dtIni       = tk_get_field_value('DATAINICIAL');
        $dtFim       = tk_get_field_value('DATAFINAL');
        $zebrado     = tk_get_field_value('ZEBRADO');
        //Não há parâmetros obrigatórios
        //Inicia o array que sera enviado para o relatorio
        $params['P_COMPETENCIA'] = $mesComp;
        $params['P_NRORG']       = $nrOrg;
        $params['P_VINCULO']     = $nrVinculo;
        $params['P_ESTRUTLEGAL'] = $nrLegal;
        $params['P_ESTRUTGEREN'] = $nrGerencial;
        $params['ZEBRADO']       = $zebrado;
        $params['P_INICIO']      = $dtIni;
        $params['P_FINAL']       = $dtFim;
        $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
        $params['CDOPERADOR']     = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']     = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Medias para rescisão para o cálculo de 13º"
    * e faz a chamada do relatório correspondênte.
    */
    public static function medias_rescisao_13($nmreport) {
        $mesComp     = tk_get_field_value('MESCOMP');
        $nrOrg       = tk_get_field_value('NRORG');
        $nrVinculo   = tk_get_field_value('NOMEVINCULOATIVO');
        $nrLegal     = tk_get_field_value('NRESTRUTURA');
        $nrGerencial = tk_get_field_value('NRESTRUTGERENCIAL');
        $dtIni       = tk_get_field_value('DATAINICIAL');
        $dtFim       = tk_get_field_value('DATAFINAL');
        $zebrado     = tk_get_field_value('ZEBRADO');
        //Não há parâmetros obrigatórios
        //Inicia o array que sera enviado para o relatorio
        $params['P_COMPETENCIA'] = $mesComp;
        $params['P_NRORG']       = $nrOrg;
        $params['P_VINCULO']     = $nrVinculo;
        $params['P_ESTRUTLEGAL'] = $nrLegal;
        $params['P_ESTRUTGEREN'] = $nrGerencial;
        $params['ZEBRADO']       = $zebrado;
        $params['P_INICIO']      = $dtIni;
        $params['P_FINAL']       = $dtFim;
        $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
        $params['CDOPERADOR']     = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']     = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Folha de Ponto"
    * e faz a chamada do relatório correspondênte.
    */
    public static function folhaPonto($nmreport){
        $nrOrg            = tk_get_field_value('NRORG');
        //$dataInicial      = tk_get_field_value('DATAINICIAL'); //Para a nova folha de ponto - PCK 03/02/2014
        //$dataFinal        = tk_get_field_value('DATAFINAL');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $mesComp          = tk_get_field_value('MESCOMP'); //Para a nova folha de ponto - PCK 03/02/2014

        /*if(($dataInicial && $dataFinal) != null){
            if(self::validateCommonDate($dataInicial,'DATAINICIAL', self::MSG_DTINI_INVALID)
                && self::validateCommonDate($dataFinal, 'DATAFINAL', self::MSG_DTFIM_INVALID)){*/
                //*Inicia o array que sera enviado para o relatorio
                $params = array();
                $params['P_COMPETENCIA']       = $mesComp; //Para a nova folha de ponto - PCK 03/02/2014
                $params['P_NRORG']             = $nrOrg;
                //$params['P_DTAPURACAOINICIAL'] = $dataInicial; //Para a nova folha de ponto - PCK 03/02/2014
                //$params['P_DTAPURACAOFINAL']   = $dataFinal;
                $params['P_NRESTRUTURA']       = $nrEstrutura;
                $params['P_NRVINCULOM']        = $nomeVinculoAtivo;
                //$params['P_CONFIDENCIAL']      = self::setQueryConfidencial('N'); //Parâmetro de confidencial
                tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
           /* }
        }else{
            tk_warning('Os campos "Data Inicial" e "Data Final" devem ser preenchidos para emissão do relatório!');
        }*/
    }

    public static function turnOver($nmreport){
        $mesComp = tk_get_field_value('MESCOMP');
        $nrOrg   = tk_get_field_value('NRORG');
        $zebrado = tk_get_field_value('ZEBRADO');

        //*Inicia o array que sera enviado para o relatorio
        $params = array();
        $params['P_DTMESCOMPETENC']  = $mesComp;
        $params['P_NRORG']           = $nrOrg;
        $params['ZEBRADO']           = $zebrado;
        $params['P_NRTIPOESTRUTURA'] = \FPA::getTipoEstruturaLegalOrg();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    /*
    * Geta para um array os parametros necessários para o relatorio "Recibo Férias"
    * e faz a chamada do relatório correspondênte.
    */
    public static function reciboFerias($nmreport){
        $nrOrg                         = tk_get_field_value('NRORG');
        $mesComp                       = tk_get_field_value('MESCOMP');
        $dataCalculoContraChequeFerias = tk_get_field_value('DATA_CALCULO_CONTRA_CHEQUE_FERIAS');
        $nrEstrutura                   = tk_get_field_value('NRESTRUTGERENCIAL');
        $nomeVinculoAtivo              = tk_get_field_value('NOMEVINCULOATIVO');

        if(($nomeVinculoAtivo && $dataCalculoContraChequeFerias) != null){
            if(self::validateCommonDate($dataCalculoContraChequeFerias, 'DATA_CALCULO_CONTRA_CHEQUE_FERIAS', self::MSG_DTCALCONTRACHEQUEFERIAS)){
                //*Inicia o array que sera enviado para o relatorio
                $params = array();
                $params['P_NRORG']                           = $nrOrg;
                $params['P_DTMESCOMPETENC']                  = $mesComp;
                $params['DATA_CALCULO_CONTRA_CHEQUE_FERIAS'] = $dataCalculoContraChequeFerias;
                $params['P_NRESTRUTURA']                     = $nrEstrutura;
                $params['P_NRVINCULO']                       = $nomeVinculoAtivo;
                $params['P_CONFIDENCIAL']                    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
                $params['CDOPERADOR']                        = \Ambiente::getCdOperador(); //Dados do operador
                $params['NMOPERADOR']                        = \Ambiente::getNmOperador();
                tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
            }
        }else{
            tk_warning('Os campos "Vínculo" e "Data de Cálculo do Contra Cheque" devem ser preenchidos para emissão do relatório!');
        }
    }

    public static function relacaoContribuicaoSindical($nmreport){
        $mesComp = tk_get_field_value('MESCOMP');
        $nrOrg   = tk_get_field_value('NRORG');
        $zebrado = tk_get_field_value('ZEBRADO');

        //*Inicia o array que sera enviado para o relatorio
        $params = array();
        $params['P_DTMESCOMPETENC'] = $mesComp;
        $params['P_NRORG']          = $nrOrg;
        $params['ZEBRADO']          = $zebrado;
        $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
        $params['CDOPERADOR']       = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']       = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function relacaoFuncionarioPorEstrutura($nmreport){
        $Competencia      = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $nrOcupacaoVinc   = tk_get_field_value('NROCUPACAOVINC');
        $nrTipoVinculo    = tk_get_field_value('NRTIPOVINCULO');
        $Zebrado          = tk_get_field_value('ZEBRADO');

        //*Inicia o array que sera enviado para o relatorio
        $params = array();
        $params['P_COMPETENCIA']     = $Competencia;
        $params['P_NRORG']           = $nrOrg;
        $params['P_VINCULO']         = $nroVinculo;
        $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
        $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
        $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
        $params['P_OCUPACAO']        = $nrOcupacaoVinc;
        $params['P_TIPOVINCULO']     = $nrTipoVinculo;
        $params['ZEBRADO']           = $Zebrado;
        $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
        $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']        = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function relacao_funcionario_por_sindicato($nmreport) {
        $Competencia      = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        //Não há parâmetros obrigatórios neste relatório
        $params = array();
        $params['P_COMPETENCIA']     = $Competencia;
        $params['P_NRORG']           = $nrOrg;
        $params['P_VINCULO']         = $nroVinculo;
        $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
        $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
        $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
        $params['ZEBRADO']           = $Zebrado;
        $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
        $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']        = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function demonstrativo_pagamento_lab02($nmreport){
        $mesComp        = tk_get_field_value('MESCOMP');
        $nrOrg          = tk_get_field_value('NRORG');
        $nrEstrutura    = tk_get_field_value('NRESTRUTURA');
        $nomeVinculo    = tk_get_field_value('NOMEVINCULOATIVO'); //NOMEVINCULO: antigo
        $nrTpModalidCal = tk_get_field_value('NRTPMODALIDCAL');
        $nrTpMoviment   = tk_get_field_value('TIPOMOVIMENTO'); //4 opções: TIPOMOVIMENTO - todas opções: NRTIPOMOVIMENT
        $zebrado        = tk_get_field_value('ZEBRADO');

        if($nrTpModalidCal == null || $nrTpMoviment == null){
            tk_warning('Os campos "Modalidade de Cálculo" e "Tipo de Movimento" devem ser preenchidos para emissão do relatório!');
        }else{
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_NRTPMODALIDCAL'] = $nrTpModalidCal;
            $params['ZEBRADO']          = $zebrado;
            $params['P_NRVINCULO']      = $nomeVinculo;
            $params['P_NRTIPOMOVIMENT'] = $nrTpMoviment;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function demonstrativo_pagamento_laser($nmreport){
        $mesComp        = tk_get_field_value('MESCOMP');
        $nrOrg          = tk_get_field_value('NRORG');
        $nrEstrutura    = tk_get_field_value('NRESTRUTURA');
        $nomeVinculo    = tk_get_field_value('NOMEVINCULOATIVO'); //NOMEVINCULO: antigo
        $nrTpModalidCal = tk_get_field_value('NRTPMODALIDCAL');
        $nrTpMoviment   = tk_get_field_value('TIPOMOVIMENTO'); //4 opções: TIPOMOVIMENTO - todas opções: NRTIPOMOVIMENT
        $zebrado        = tk_get_field_value('ZEBRADO');

        if($nrTpModalidCal == null || $nrTpMoviment == null){
            tk_warning('Os campos "Modalidade de Cálculo" e "Tipo de Movimento" devem ser preenchidos para emissão do relatório!');
        }else{
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTURA']    = $nrEstrutura;
            $params['P_NRTPMODALIDCAL'] = $nrTpModalidCal;
            $params['ZEBRADO']          = $zebrado;
            $params['P_NRVINCULO']      = $nomeVinculo;
            $params['P_NRTIPOMOVIMENT'] = $nrTpMoviment;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencial
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function funcionariosAdmitidosPeriodo($nmreport) {
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $dataInicial      = tk_get_field_value('DATAINICIAL');
        $dataFinal        = tk_get_field_value('DATAFINAL');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');

       /* if($dataInicial == null || $dataFinal == null) {
            tk_warning('Os campos "Data Inicial" e "Data Final" devem ser preenchidos para emissão do relatório Funcionários Admitidos por Período.');
        } else {*/
            //if(self::validateCommonDate($dataInicial,'DATAINICIAL', self::MSG_DTINI_INVALID)
            //& self::validateCommonDate($dataFinal, 'DATAFINAL', self::MSG_DTFIM_INVALID)){
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC']   = $mesComp;
            $params['P_NRORG']            = $nrOrg;
            $params['ZEBRADO']            = $zebrado;
            $params['P_NRESTRUTURA']      = $nrEstrutura;
            $params['P_NRESTRUTURAGEREN'] = $nrEstruturaGeren;
            $params['P_DTINICIAL']        = $dataInicial;
            $params['P_DTFINAL']          = $dataFinal;
            $params['P_INCLUIRDEMITIDO']  = $IncluirDemitidos;
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            $params['CDOPERADOR']         = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']         = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
       // }
    }

    public static function funcionariosDemitidosPeriodo($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $dataInicial      = tk_get_field_value('DATAINICIAL');
        $dataFinal        = tk_get_field_value('DATAFINAL');

        if(($dataInicial && $dataFinal) != null){

            if(self::validateCommonDate($dataInicial,'DATAINICIAL', self::MSG_DTINI_INVALID)
                & self::validateCommonDate($dataFinal, 'DATAFINAL', self::MSG_DTFIM_INVALID)){
                //*Inicia o array que sera enviado para o relatorio
                $params = array();
                $params['P_DTMESCOMPETENC']   = $mesComp;
                $params['P_NRORG']            = $nrOrg;
                $params['ZEBRADO']            = $zebrado;
                $params['P_NRESTRUTURA']      = $nrEstrutura;
                $params['P_NRESTRUTURAGEREN'] = $nrEstruturaGeren;
                $params['P_DTINICIAL']        = $dataInicial;
                $params['P_DTFINAL']          = $dataFinal;
                $params['P_CONFIDENCIAL']     = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
                tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
            }
        }else{
            tk_warning('Os campos "Data Inicial" e "Data Final" devem ser preenchidos para emissão do relatório!');
        }
    }

    public static function controleContratoExperiencia($nmreport){
        $mesComp          = tk_get_field_value('MESCOMP');
        $nrOrg            = tk_get_field_value('NRORG');
        $nomeVinculoAtivo = tk_get_field_value('NOMEVINCULOATIVO');
        $zebrado          = tk_get_field_value('ZEBRADO');
        $nrEstrutura      = tk_get_field_value('NRESTRUTURA');

        //*Inicia o array que sera enviado para o relatorio
        $params = array();
        $params['P_DTMESCOMPETENC'] = $mesComp;
        $params['P_NRORG']          = $nrOrg;
        $params['P_NRVINCULO']      = $nomeVinculoAtivo;
        $params['ZEBRADO']          = $zebrado;
        $params['P_NRESTRUTLEGAL']  = $nrEstrutura;
        $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function etiqueta($nmreport){
        $mesComp       = tk_get_field_value('MESCOMP');
        $nrOrg         = tk_get_field_value('NRORG');
        $nrEstrutLegal = tk_get_field_value('NRESTRUTURA'); //pck
        //$nrEstrutura = tk_get_field_value('NRESTRUTURA');
        $nomeVinculo   = tk_get_field_value('NOMEVINCULOATIVO');
        $estrutGeren   = tk_get_field_value('NRESTRUTGERENCIAL'); //pck
        $dtInicialAdm  = tk_get_field_value('DATAINICIAL'); //pck
        $dtFinalAdm    = tk_get_field_value('DATAFINAL'); //pck

        if($mesComp != null && $nrOrg != null && $dtInicialAdm != null && $dtFinalAdm != null /*$nomeVinculo != null*/){ //pck
            //*Inicia o array que sera enviado para o relatorio
            $params = array();
            $params['P_DTMESCOMPETENC'] = $mesComp;
            $params['P_NRORG']          = $nrOrg;
            $params['P_NRESTRUTLEGAL']  = $nrEstrutLegal; //pck
            $params['P_NRVINCULO']      = $nomeVinculo;
            $params['P_ESTRUTGEREN']    = $estrutGeren;
            $params['P_DTINIADM']       = $dtInicialAdm;
            $params['P_DTFIMADM']       = $dtFinalAdm;
            //$params['P_NRESTRUTURA'] = $nrEstrutura;
            $params['P_CONFIDENCIAL']   = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }else{
            tk_warning('Os campos "Mês de competência", "Nro da Organização", "Data inicial" e "Datza final" devem ser preenchido para emissão do relatório!'); //pck
        }
    }

    public static function avisoprevioempregado($nmreport){
        $nrvinculom = tk_get_field_value('NOMEVINCULOATIVO');
        $nrorg      = tk_get_field_value('NRORG');
        $dtaviso    = tk_get_field_value('DATAAVISOPREV');

        if($nrvinculom != null && $dtaviso != null) {
            $params = array();
            $params['P_NRVINCULOM']   = $nrvinculom;
            $params['P_NRORG']        = $nrorg;
            $params['P_DTAVISO']      = $dtaviso;
            $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        } else {
            tk_warning('Os campos "Vínculo" e "Data do Aviso Prévio" devem ser preenchidos para a emissão do relatório!');
        }
    }

    public static function avisoprevioempregador($nmreport){
        //tk_warning('Este relatório está em processo de reformulação.');
        $nrvinculom = tk_get_field_value('NOMEVINCULOATIVO');
        $nrorg      = tk_get_field_value('NRORG');
        $dtaviso    = tk_get_field_value('DATAAVISOPREV');
        $tipoaviso  = tk_get_field_value('TIPO_AVISO');
        //tk_warning('tipo: '.$tipoaviso.', dtaviso: '.$dtaviso);

        if($nrvinculom == null) {
            tk_warning('O campo "Vínculo" deve ser preenchido para emissão do relatório!');
        } else {
            if($tipoaviso == 'N' && $dtaviso == null) {//Se o aviso for trabalhado o relatorio precisará da dtaviso, caso contrário elá é opcional
                tk_warning('Para aviso prévio trabalhado precisa-se informar a data de rescisão.');
            } else {
                $params = array();
                $params['P_NRVINCULOM'] = $nrvinculom;
                $params['P_NRORG']      = $nrorg;
                $params['P_DTAVISO']    = $dtaviso;
                $params['P_TIPOAVISO']  = $tipoaviso;
                $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
                tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
            }
        }
    }

    public static function darf($nmreport) {
        $NRORG             = tk_get_field_value('NRORG');
        $MESCOMP           = tk_get_field_value('MESCOMP');
        $NOMEVINCULO       = tk_get_field_value('NOMEVINCULOATIVO');
        $NRESTRUTURA       = tk_get_field_value('NRESTRUTURA');
        $NRESTRUTGERENCIAL = tk_get_field_value('NRESTRUTGERENCIAL');
        $NRTIPOMOVIMENT    = tk_get_field_value('TIPOMOVIMENTO'); //4 opções: TIPOMOVIMENTO - todas opções: NRTIPOMOVIMENT
        $NRMODALIDADCAL    = tk_get_field_value('NRTPMODALIDCAL');
        $MULTA             = tk_get_field_value('MULTA');
        $JUROSENCARGOS     = tk_get_field_value('JUROSENCARGOS');
        $DATAVENCIMENTO    = tk_get_field_value('DATAVENCIMENTO');
        $PERIODOAPURACAO   = tk_get_field_value('PERIODOAPURACAO');
        $CODIGORECEITA     = tk_get_field_value('CODIGORECEITA');
        $NRTIPOESTRUTURA   = tk_get_field_value('NRTIPOESTRUTHIERARQ'); //do campo 'Agrupar por'
        if($MULTA == null || $JUROSENCARGOS == null || $DATAVENCIMENTO == null || $PERIODOAPURACAO == null || $CODIGORECEITA == null || $NRTIPOMOVIMENT == null) {
            tk_warning('Os campos "Tipo de Movimento", "Multa", "Juros e encargos", "Data de vencimento", "Período de apuração" e "Código da receita" devem ser preenchidos para a emissão do DARF!');
        } else {
            $params = array();
            $params['P_NRORG']           = $NRORG;
            $params['P_COMPETENCIA']     = $MESCOMP;
            $params['P_NRVINCULOM']      = $NOMEVINCULO;
            $params['P_NRESTRUTURA']     = $NRESTRUTURA;
            $params['P_NRESTRUTGEREN']   = $NRESTRUTGERENCIAL;
            $params['P_NRTIPOMOVIMENT']  = $NRTIPOMOVIMENT;
            $params['P_NRMODALIDADECAL'] = $NRMODALIDADCAL;
            $params['P_MULTA']           = $MULTA;
            $params['P_JUROSENCARGOS']   = $JUROSENCARGOS;
            $params['P_DTVENCIMENTO']    = $DATAVENCIMENTO;
            $params['P_PERIODOAPURACAO'] = $PERIODOAPURACAO;
            $params['P_CODIGORECEITA']   = $CODIGORECEITA;
            $params['P_TP_ESTRUT_BUSCA'] = $NRTIPOESTRUTURA;
            $params['P_OCORRECAL']       = \FPA::getOcorrenciaCalculo(); //PCK
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial(tk_get_field_value('SELECAOCONF')); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function gps($nmreport) {
        $NRORG             = tk_get_field_value('NRORG');
        $MESCOMP           = tk_get_field_value('MESCOMP');
        $NRESTRUTURA       = tk_get_field_value('NRESTRUTURA');
        $NRESTRUTGERENCIAL = tk_get_field_value('NRESTRUTGERENCIAL');
        $NRTIPOESTRUTURA   = tk_get_field_value('NRTIPOESTRUTHIERARQ'); //do campo 'Agrupar por'
        $NRTIPOMOVIMENT    = tk_get_field_value('TIPOMOVIMENTO'); //4 opções: TIPOMOVIMENTO - todas opções: NRTIPOMOVIMENT
        $NRMODALIDADCAL    = tk_get_field_value('NRTPMODALIDCAL');
        if($NRTIPOESTRUTURA == null) {
            tk_warning('O campo "Agrupar por" deve ser preenchido para a emissão da GPS');
        } else {
            $params = array();
            $params['P_NRORG']           = $NRORG;
            $params['P_COMPETENCIA']     = $MESCOMP;
            $params['P_NRESTRUTURA']     = $NRESTRUTURA;
            $params['P_NRESTRUTGEREN']   = $NRESTRUTGERENCIAL;
            $params['P_NRTIPOESTRUTURA'] = $NRTIPOESTRUTURA;
            $params['P_MOVIMENTO']       = $NRTIPOMOVIMENT;
            $params['P_MODALIDADE']      = $NRMODALIDADCAL;
            $params['P_OCORRECAL']       = \FPA::getOcorrenciaCalculo(); //PCK
            $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function seguro_desemprego($nmreport) {
        $NRORG            = tk_get_field_value('NRORG');
        $MESCOMP          = tk_get_field_value('MESCOMP');
        $NRESTRUTURALEGAL = tk_get_field_value('NRESTRUTURA');
        $NRESTRUTURAGEREN = tk_get_field_value('NRESTRUTGERENCIAL');
        $NRTIPOMOVIMENT   = tk_get_field_value('TIPOMOVIMENTO'); //4 opções: TIPOMOVIMENTO - todas opções: NRTIPOMOVIMENT
        $NROVINCULO       = tk_get_field_value('NOMEVINCULOATIVO'); //pck
        //$NROVINCULO       = tk_get_field_value('NOMEVINCULO'); //pck
        $DATAINICIAL      = tk_get_field_value('DATAINICIAL');
        $DATAFINAL        = tk_get_field_value('DATAFINAL');
        $NRMODALIDADCAL   = tk_get_field_value('NRTPMODALIDCAL');
        //$CENARIO = \FpaTpmodalidcal::retornaTipoModalidadeCalculo()
        if($DATAFINAL == null || $DATAINICIAL == null || $NRMODALIDADCAL == null) {
            tk_warning('Os campos de datas e a Modalidade de cálculo devem ser preenchidos para a emissão do Seguro desemprego.');
        } else {
            $params = array();
            $params['P_NRORG']            = $NRORG;
            $params['P_NRVINCULO']        = $NROVINCULO;
            $params['P_COMPETENCIA']      = $MESCOMP;
            $params['P_DATAINICIAL']      = $DATAINICIAL;
            $params['P_DATAFINAL']        = $DATAFINAL;
            $params['P_NRESTRUTURALEGAL'] = $NRESTRUTURALEGAL;
            $params['P_NRESTRUTURAGEREN'] = $NRESTRUTURAGEREN;
            $params['P_TIPOMOVIMENTO']    = $NRTIPOMOVIMENT;
            $params['P_MODALIDADECAL']    = $NRMODALIDADCAL;
            $params['P_OCORRECAL']        = \FPA::getOcorrenciaCalculo(); //PCK Nova ver
            $params['P_CONFIDENCIAL']     = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function previsao_ferias($nmreport) {
        $NRORG            = tk_get_field_value('NRORG');
        $MESCOMP          = tk_get_field_value('MESCOMP');
        $NRESTRUTURALEGAL = tk_get_field_value('NRESTRUTURA');
        $NRESTRUTURAGEREN = tk_get_field_value('NRESTRUTGERENCIAL');
        $ZEBRADO          = tk_get_field_value('ZEBRADO');
        //Nenhum campo é obrigatório, não há nnecessidade de verificar
        $params = array();
        $params['P_NRORG']        = $NRORG;
        $params['P_COMPETENCIA']  = $MESCOMP;
        $params['P_ESTRUTLEGAL']  = $NRESTRUTURALEGAL;
        $params['P_ESTRUTGEREN']  = $NRESTRUTURAGEREN;
        $params['ZEBRADO']        = $ZEBRADO;
        $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        $params['CDOPERADOR']     = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']     = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function conta_funcionario($nmreport) {
        $NRORG            = tk_get_field_value('NRORG');
        $MESCOMP          = tk_get_field_value('MESCOMP');
        $NRESTRUTURALEGAL = tk_get_field_value('NRESTRUTURA');
        $NRESTRUTURAGEREN = tk_get_field_value('NRESTRUTGERENCIAL');
        $NROVINCULO       = tk_get_field_value('NOMEVINCULOATIVO'); //pck
        //$NROVINCULO       = tk_get_field_value('NOMEVINCULO');
        $ZEBRADO          = tk_get_field_value('ZEBRADO');
        //Nenhum campo é obrigatório, não há nnecessidade de verificar
        $params = array();
        $params['P_NRORG']        = $NRORG;
        $params['P_COMPETENCIA']  = $MESCOMP;
        $params['P_ESTRUTLEGAL']  = $NRESTRUTURALEGAL;
        $params['P_ESTRUTGEREN']  = $NRESTRUTURAGEREN;
        $params['P_VINCULO']      = $NROVINCULO;
        $params['ZEBRADO']        = $ZEBRADO;
        $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function estruturas_tipo_hierarquia($nmreport) {
        $NRORG           = tk_get_field_value('NRORG');
        $MESCOMP         = tk_get_field_value('MESCOMP');
        $NRTIPOESTRUTURA = tk_get_field_value('NRTIPOESTRUTHIERARQ'); //do campo 'Agrupar por'
        $ZEBRADO         = tk_get_field_value('ZEBRADO');
        if($NRTIPOESTRUTURA == null) {
            tk_warning('O campo "Agrupar por" deve ser preenchido para a emissão do relatório Estruturas por tipo de hierarquia.');
        } else {
            $params = array();
            $params['P_NRORG']         = $NRORG;
            $params['P_COMPETENCIA']   = $MESCOMP;
            $params['P_TIPOESTRUTURA'] = $NRTIPOESTRUTURA;
            $params['ZEBRADO']         = $ZEBRADO;
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function aniversariantes($nmreport) {
        $NRORG            = tk_get_field_value('NRORG');
        $MESCOMP          = tk_get_field_value('PERIODOAPURACAO');
        $NRESTRUTURALEGAL = tk_get_field_value('NRESTRUTURA');
        $NRESTRUTURAGEREN = tk_get_field_value('NRESTRUTGERENCIAL');
        $ZEBRADO          = tk_get_field_value('ZEBRADO');
        if($MESCOMP == null) {
            tk_warning('O campo de data deve ser preenchido para a emissão do relatório de Aniversariantes do mês.');
        } else {
            $params = array();
            $params['P_NRORG']       = $NRORG;
            $params['P_MES']         = $MESCOMP;
            $params['P_ESTRUTGEREN'] = $NRESTRUTURALEGAL;
            $params['P_ESTRUTLEGAL'] = $NRESTRUTURAGEREN;
            $params['ZEBRADO']       = $ZEBRADO;
            $params['P_CONFIDENCIAL'] = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function comparacao_calculos_folha($nmreport) {
        $NRORG            = tk_get_field_value('NRORG');
        $NRCALCULOFOLHA_1 = tk_get_field_value('NRCALCULOFOLHA_1');
        $NRCALCULOFOLHA_2 = tk_get_field_value('NRCALCULOFOLHA_2');
        $ZEBRADO          = tk_get_field_value('ZEBRADO');
        if($NRCALCULOFOLHA_1 == null || $NRCALCULOFOLHA_2 == null) {
            tk_warning('Os campos de números de cálculo de folha devem ser preeenchidos para a emissão do relatório Comparação de Cálculos de Folha.');
        } else {
            $params = array();
            $params['P_NRORG']            = $NRORG;
            $params['P_NRCALCULOFOLHA_1'] = $NRCALCULOFOLHA_1;
            $params['P_NRCALCULOFOLHA_2'] = $NRCALCULOFOLHA_2;
            $params['ZEBRADO']            = $ZEBRADO;
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function assoc_eventos_vinculo_e($nmreport) {
        $NRORG       = tk_get_field_value('NRORG');
        $COMPETENCIA = tk_get_field_value('MESCOMP');
        $NRVINCULO   = tk_get_field_value('NOMEVINCULOATIVO'); //pck
        //$NRVINCULO   = tk_get_field_value('NOMEVINCULO');
        $DTINICIO    = tk_get_field_value('DATAINICIAL');
        $DTFINAL     = tk_get_field_value('DATAFINAL');
        //Não há parâmetros obrigatórios
        $params = array();
        $params['P_NRORG']       = $NRORG;
        $params['P_COMPETENCIA'] = $COMPETENCIA;
        $params['P_NRVINCULO']   = $NRVINCULO;
        $params['P_INIVIGENCIA'] = $DTINICIO;
        $params['P_FIMVIGENCIA'] = $DTFINAL;
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function assoc_eventos_vinculo_v($nmreport) {
        $NRORG       = tk_get_field_value('NRORG');
        $COMPETENCIA = tk_get_field_value('MESCOMP');
        $NRVINCULO   = tk_get_field_value('NOMEVINCULOATIVO'); //pck
        //$NRVINCULO   = tk_get_field_value('NOMEVINCULO');
        $DTINICIO    = tk_get_field_value('DATAINICIAL');
        $DTFINAL     = tk_get_field_value('DATAFINAL');
        //Não há parâmetros obrigatórios
        $params = array();
        $params['P_NRORG']       = $NRORG;
        $params['P_COMPETENCIA'] = $COMPETENCIA;
        $params['P_NRVINCULO']   = $NRVINCULO;
        $params['P_INIVIGENCIA'] = $DTINICIO;
        $params['P_FIMVIGENCIA'] = $DTFINAL;
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function assoc_estrutura_evento($nmreport) {
        $NRORG       = tk_get_field_value('NRORG');
        $COMPETENCIA = tk_get_field_value('MESCOMP');
        $DTINICIO    = tk_get_field_value('DATAINICIAL');
        $DTFINAL     = tk_get_field_value('DATAFINAL');
        //Não há parâmetros obrigatórios
        $params = array();
        $params['P_NRORG']       = $NRORG;
        $params['P_COMPETENCIA'] = $COMPETENCIA;
        $params['P_INIVIGENCIA'] = $DTINICIO;
        $params['P_FIMVIGENCIA'] = $DTFINAL;
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    //verificar estes últimos !!!!!!!!!!!!!!!!!!!!!!!1
    public static function eventos_relacionados_vinculo($nmreport) {
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $NrEvento         = tk_get_field_value('NREVENTO'); //pck
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS'); //pck
        $nrTpModalidCal   = tk_get_field_value('NRTPMODALIDCAL');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        if($NrEvento == null || $nrTpModalidCal == null) {
            tk_warning('Os parâmetros "Número do Evento" e "Modalidade de Cálculo" devem ser preenchidos para a emissão do relatório Ocorrência de eventos no vínculo.');
        } else {
            $params = array();
            $params['P_NRORG']           = $nrOrg;
            $params['P_COMPETENCIA']     = $Competencia;
            $params['P_ESTRUTURALEGAL']  = $nrEstruturaLegal;
            $params['P_ESTRUTURAGEREN']  = $nrEstruturaGeren;
            $params['P_VINCULO']         = $NroVinculo;
            $params['P_NREVENTO']        = $NrEvento;
            $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
            $params['P_MODALIDADECAL']   = $nrTpModalidCal;
            $params['ZEBRADO']           = $Zebrado;
            $params['P_OCORRECAL']       = \FPA::getOcorrenciaCalculo();
            $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function tomadores($nmreport) {
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        //Não há parâmetro obrigatórios
        $params = array();
        $params['P_NRORG']           = $nrOrg;
        $params['P_COMPETENCIA']     = $Competencia;
        $params['P_VINCULO']         = $NroVinculo;
        $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
        $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
        $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
        $params['ZEBRADO']           = $Zebrado;
        $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']        = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function alteracao_salarial($nmreport) {
        //continuar...
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $DataInicio       = tk_get_field_value('DATAINICIAL');
        $DataFinal        = tk_get_field_value('DATAFINAL');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        //Não há parâmetro obrigatórios
        $params = array();
        $params['P_NRORG']           = $nrOrg;
        $params['P_COMPETENCIA']     = $Competencia;
        $params['P_VINCULO']         = $NroVinculo;
        $params['P_INICIO']          = $DataInicio;
        $params['P_FINAL']           = $DataFinal;
        $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
        $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
        $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
        $params['ZEBRADO']           = $Zebrado;
        $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']        = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function alteracao_funcional($nmreport) {
        //continuar...
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $DataInicio       = tk_get_field_value('DATAINICIAL');
        $DataFinal        = tk_get_field_value('DATAFINAL');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        //Não há parâmetro obrigatórios
        $params = array();
        $params['P_NRORG']           = $nrOrg;
        $params['P_COMPETENCIA']     = $Competencia;
        $params['P_VINCULO']         = $NroVinculo;
        $params['P_INICIO']          = $DataInicio;
        $params['P_FINAL']           = $DataFinal;
        $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
        $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
        $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
        $params['ZEBRADO']           = $Zebrado;
        $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']        = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function lancamentos_evento_vinculo($nmreport) {
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $TipoMovimento    = tk_get_field_value('NRTIPOMOVIMENT');
        $ModalidadeCalc   = tk_get_field_value('NRTPMODALIDCAL');
        $NrEvento         = tk_get_field_value('NREVENTO');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        if($NrEvento == null || $ModalidadeCalc == null || $TipoMovimento == null) {
            tk_warning('Os parâmetros "Número do evento", "Modalidade de cálculo" e "Tipo de movimento" devem ser preenchidos para a emissão do relatório Lançamentos de Eventos por Vícnulo.');
        } else {
            $params = array();
            $params['P_NRORG']           = $nrOrg;
            $params['P_COMPETENCIA']     = $Competencia;
            $params['P_VINCULO']         = $NroVinculo;
            $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
            $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
            $params['P_TIPOMOVIMENTO']   = $TipoMovimento;
            $params['P_MODALIDADECAL']   = $ModalidadeCalc;
            $params['P_NREVENTO']        = $NrEvento;
            $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
            $params['ZEBRADO']           = $Zebrado;
            $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']        = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    public static function relacao_eventos_estrutura_e_vinculo($nmreport) {
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        //Não há parâmetro obrigatórios
        $params = array();
        $params['P_NRORG']           = $nrOrg;
        $params['P_COMPETENCIA']     = $Competencia;
        $params['P_VINCULO']         = $NroVinculo;
        $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
        $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
        $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
        $params['ZEBRADO']           = $Zebrado;
        $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
        $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
        $params['NMOPERADOR']        = \Ambiente::getNmOperador();
        tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

    public static function evento_zerado_por_vinculo($nmreport) {
        $nrOrg            = tk_get_field_value('NRORG');
        $Competencia      = tk_get_field_value('MESCOMP');
        $NroVinculo       = tk_get_field_value('NOMEVINCULOATIVO');
        $nrEstruturaLegal = tk_get_field_value('NRESTRUTURA');
        $nrEstruturaGeren = tk_get_field_value('NRESTRUTGERENCIAL');
        $IncluirDemitidos = tk_get_field_value('INCLUIRDEMITIDOS');
        $Zebrado          = tk_get_field_value('ZEBRADO');
        $ModalidadeCalc   = tk_get_field_value('NRTPMODALIDCAL');
        $TipoMovimento    = tk_get_field_value('NRTIPOMOVIMENT');
        $NrEvento         = tk_get_field_value('NREVENTO');
        if( $ModalidadeCalc == null || $TipoMovimento == null ) {
            tk_warning('Os parâmetros "Modalidade de Cálculo" e "Tipo do Movimento" devem ser preenchidos para a emissão do relatório "Eventos Zerados ou Negativos do Vínculo".');
        } else {
            $params = array();
            $params['P_NRORG']           = $nrOrg;
            $params['P_COMPETENCIA']     = $Competencia;
            $params['P_VINCULO']         = $NroVinculo;
            $params['P_ESTRUTLEGAL']     = $nrEstruturaLegal;
            $params['P_ESTRUTGEREN']     = $nrEstruturaGeren;
            $params['P_INCLUIRDEMITIDO'] = $IncluirDemitidos;
            $params['ZEBRADO']           = $Zebrado;
            $params['P_NRTPMODALIDCAL']  = $ModalidadeCalc;
            $params['P_NRTPMOVIMENT']    = $TipoMovimento;
            $params['P_NREVENTO']        = $NrEvento;
            $params['P_CONFIDENCIAL']    = self::setQueryConfidencial('nao_conf'); //Parâmetro de confidencialidade
            $params['CDOPERADOR']        = \Ambiente::getCdOperador(); //Dados do operador
            $params['NMOPERADOR']        = \Ambiente::getNmOperador();
            tk_open_report_from_array($nmreport, $params,  \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
        }
    }

    /*
     * Seta o campo "Estrutura de Trabalho" quando a data de competência mudar no evento "onBlur".
     * NÂO USADO ATUALMENTE
     */
    public static function setWorkStructureFieldWhenCompetenceDateChange($competenceDate, $workingNrorg,
                                                                         $competenceDateNameField, $workingStructureNameField){

        if(self::validateDate($competenceDate)){
            $ajustedCompetenceDate = self::setCompetenceDateDayToOne($competenceDate);

            tk_set_field_value("$competenceDateNameField", $ajustedCompetenceDate);

            self::enableFieldsWhenCompetenceDateIsValid();
            //self::setValidWorkStructure($ajustedCompetenceDate, $workingNrorg, $workingStructureNameField);
        }else{

            if($competenceDate == null){
                $competenceDate = date("d/m/Y",mktime(0, 0, 0, (date("m")), 1, date("Y")));

                tk_set_field_value("$competenceDateNameField", $competenceDate);

                self::enableFieldsWhenCompetenceDateIsValid();
                //self::setValidWorkStructure($competenceDate, $workingNrorg, $workingStructureNameField);
            }else{

                self::disableFieldsWhenCompetenceDateIsUnvalid();
                tk_warning('"Data de Competência" inválida!');
            }
        }

    }

    /*
     * Seta uma estrutura válida de acordo com a data de competência no campo "Estrutura de Trabalho"
     * NÂO USADO ATUALMENTE
     */
    public static function setValidWorkStructure($competenceDate, $workingNrorg, $workingStructureNameField){

        $result = EstruturahEntity::returnWorkStructureFromOrgAndCompetenceDate($workingNrorg, $competenceDate);

        if($result){
            tk_set_field_value("$workingStructureNameField", $result);
        }else{
            tk_warning('Não existe estrututura nessa data de competência');
        }
    }

    /*
     * Seta a data corrente com o primeiro dia do mês como "default value" no campo "Data de Competência"
     */
    public static function setCurrentCompetenceDate($nrorg,$cdoperador){

        $parametro = new Parametros($nrorg,$cdoperador);
        $data = new TkDateTime($parametro->getMesCompetencia());
        $return = $data->toString(TkDateTime::DAY.'/'.TkDateTime::MONTH.'/'.TkDateTime::YEAR);

        return $return;

//        return date("d/m/Y",mktime(0, 0, 0, (date("m")), 1, date("Y")));
    }

    /*
     * Seta como default value no campo "Estrutura de Trabalho" uma estrutura válida de acordo
     * com a data de competência corrente.
     * NAO USADO ATUALMENTE
     */
    public static function setWorkStructureDefaultValue(){
        $workNrorg = Ambiente::getNrorgSelecionada();
        $competenceDate = date("d/m/Y",mktime(0, 0, 0, (date("m")), 1, date("Y")));

        $result = EstruturahEntity::returnWorkStructureFromOrgAndCompetenceDate($workNrorg, $competenceDate);

        if($result){
            return $result;
        }else{
            tk_warning('Não existe estrututura nessa data de competência');
        }
    }

    public static function setContextVars($nrestrutura){

        if($nrestrutura){
            tk_set_context_vars('NRESTRUTURA','fpa_relatorio',$nrestrutura);
        }else{
            tk_set_context_vars('NRESTRUTURA','fpa_relatorio',null);
        }
        //O original apenas continha: tk_set_context_vars('NRESTRUTURA','fpa_relatorio',$nrestrutura);
    }

    /*
     *Seta uma estrutura válida de acordo com a data de competência quando o campo "Estrutura de Trabalho"
     * estiver null.

    public static function setWorkStructureWhenFieldValueIsNull($workingStructure, $workingNrorg, $competenceDate,
                                                                $workingStructureNameField){

        /*
        if($workingStructure == null){

            $result = EstruturahEntity::returnWorkStructureFromOrgAndCompetenceDate($workingNrorg, $competenceDate);

            if($result){
                tk_set_field_value("$workingStructureNameField", $result);
            }else{
                tk_warning('Não existe estrututura nessa data de competência');
            }
        }


    }
    */

    /*
     * Valida se está no formato de data a data de competência digitada pelo usuário;
     */
    public static function validateDate($date){

        if (preg_match('/^\d{1,2}\/\d{1,2}\/\d{4}$/', $date)) {

            $date = explode('/', $date, 3);
            $day = $date[0];
            $month = $date[1];
            $year = $date[2];
            $currentYear = date('Y');

            if(($day >= 1 && $day <= 31) && ($month >=1 && $month <= 12) /*&& ( $year <= $currentYear )*/ ){
                return TRUE;
            }

            return FALSE;

        }else{
            return FALSE;
        }
    }

    /*
     * Seta o dia  uma data de competencia formatada corretamente para 1
     */
    public static function setCompetenceDateDayToOne($competenceDate){
        $competenceDateAux = explode('/', $competenceDate, 3);
        $day = $competenceDateAux[0];

        if($day != '01'){
            $day = '01';
            $month = $competenceDateAux[1];
            $year = $competenceDateAux[2];
            $competenceDateAux = array($day, $month, $year);

            $ajustedCompetenceDate = implode("/", $competenceDateAux);

            return $ajustedCompetenceDate;
        }else{
            return $competenceDate;
        }
    }

    /*
     * Valida se um campo de Data de Competência contém uma data de competência válida.
     */
    public static function validateCompetenceDate($competenceDate, $competenceDateFieldName){

        if(self::validateDate($competenceDate)){
            $ajustedCompetenceDate = self::setCompetenceDateDayToOne($competenceDate);

            tk_set_field_value("$competenceDateFieldName", $ajustedCompetenceDate);

            self::enableFieldsWhenCompetenceDateIsValid();
        }else{

            if($competenceDate == null){
                $competenceDate = date("d/m/Y",mktime(0, 0, 0, (date("m")), 1, date("Y")));

                tk_set_field_value("$competenceDateFieldName", $competenceDate);

                self::enableFieldsWhenCompetenceDateIsValid();
            }else{

                self::disableFieldsWhenCompetenceDateIsUnvalid();
                tk_enable_field("$competenceDateFieldName");
                tk_warning('"Data de Competência" inválida!');
            }
        }
    }

    /*
     * Valida se o conteúdo de um campo de data comum é uma data válida.
     */
    public static function validateCommonDate($date, $fieldName, $message=null){

        if(!(self::validateDate($date))){
            tk_set_field_value("$fieldName", null);

            if($message != null){
                tk_warning($message);
            }else{
                tk_warning('Data inválida! Insira a data novamente.');
            }
            return FALSE;
        }else{
            return TRUE;
        }
    }

    /*
     * Função chamada no evento "onChange" do campo "Data de Competência"
     */
    public static function setNullWhenChange(){

        tk_set_field_value('NOMEVINCULOATIVO', null);
        tk_set_field_value('NOMEVINCULOATIVO__LABEL', null);
        tk_set_field_value('NOMEVINCULO', null);
        tk_set_field_value('NOMEVINCULO__LABEL', null);
    }

    public static function setFixedT(){

        //try deve ser usado desta maneira - bug setforms
        try{

            $nrestrutura = tk_get_context_vars('NRESTRUTURA','fpa_relatorio',null);
            tk_message('Estrutura ' . $nrestrutura,'info');
            return $nrestrutura;

        }catch (Exception $e){

            tk_message('Sem Estrutura','info');
            return 'T';
        }
    }

    /**
     * Recebe o nome do relatório pelo botão e chamando o metodo termos rescisórios e enviando
     * o parametro recebido pelo respectivo botão: TRCT, THRCT ou TQRCT
     *
     * @param string $nmreport Nome do Relatorio.
     *
     * @return void
     *
     * @author - brunoborba
     */
    public static function geraTermo($nmreport) {

        //*Inicia o array que sera enviado para o relatorio
        $params = array();
        $params['P_DTMESCOMPETENC'] = \FPA::getDtCompetencia();
        $params['P_NRORG']          = \FPA::getNrorgTrabalho();
        $params['P_NRVINCULO']      = tk_get_field_value('NOMEVINCULO');
        $params['ZEBRADO']          = tk_get_field_value('ZEBRADO');
        $params['P_NRESTRUTLEGAL']  = tk_get_field_value('NRESTRUTURA');
        $params['P_OCORRECAL']      = \FPA::getOcorrenciaCalculo(); //PCK. Para o trct (cálculo folha), item de cálculo que retorna a remuneração
        tk_open_report_from_array($nmreport, $params, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
    }

}

